<?php

namespace App\Service\Action;

use App\Response\ApiResponse;
use App\Service\Dto\DtoServiceInterface;
use App\Service\Response\ResponseServiceInterface;

abstract class BaseActionService implements ActionServiceInterface
{
    protected ?ResponseServiceInterface $responseService;

    public function __construct(
        ResponseServiceInterface $baseResponseService,
    )
    {
        $this->responseService = $baseResponseService;
    }

    public function getResponse(): ApiResponse
    {
        if ($this->validate()) {
            $this->runAction();
        }

        if ($this->responseService) {
            return $this->responseService->getResponse();
        }

        $response = new ApiResponse();
        $response->addError('Ошибка получения ответа');
        return $response;
    }
}